﻿// CodeGear C++Builder
// Copyright (c) 1995, 2020 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'FMX.uecMappilary.pas' rev: 34.00 (Windows)

#ifndef Fmx_UecmappilaryHPP
#define Fmx_UecmappilaryHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <System.SysUtils.hpp>
#include <System.Types.hpp>
#include <System.UITypes.hpp>
#include <System.Rtti.hpp>
#include <System.Classes.hpp>
#include <System.SyncObjs.hpp>
#include <System.UIConsts.hpp>
#include <System.Generics.Collections.hpp>
#include <System.Generics.Defaults.hpp>
#include <FMX.uecMapUtil.hpp>
#include <FMX.uecHttp.hpp>
#include <FMX.uecNativeMapControl.hpp>
#include <FMX.uecNativeShape.hpp>
#include <FMX.uecMapZip.hpp>
#include <System.StrUtils.hpp>
#include <System.IOUtils.hpp>
#include <FMX.Graphics.hpp>
#include <FMX.Types.hpp>
#include <FMX.Controls.hpp>
#include <FMX.Forms.hpp>
#include <FMX.Objects.hpp>
#include <FMX.Platform.hpp>

//-- user supplied -----------------------------------------------------------

namespace Fmx
{
namespace Uecmappilary
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TMappilaryImage;
class DELPHICLASS TMappilaryImageList;
class DELPHICLASS TMappilarySequence;
class DELPHICLASS TMappilarySequenceList;
class DELPHICLASS TThreadMappilarySearchSequence;
class DELPHICLASS TThreadMappilarySearchImage;
class DELPHICLASS TThreadMappilarygetImage;
class DELPHICLASS TMappilaryAPI;
class DELPHICLASS TECMappilaryLayer;
//-- type declarations -------------------------------------------------------
typedef System::DynamicArray<double> TMappilaryCas;

typedef System::DynamicArray<Fmx::Uecmaputil::TLatLng> TMappilaryCoord;

enum DECLSPEC_DENUM TMappilaryThumbSize : unsigned char { Thumb320, Thumb640, Thumb1024, Thumb2048 };

enum DECLSPEC_DENUM TMappilaryConnexion : unsigned char { mcOnlyMappilaryServer, mcOnlyLocal, mcLocalOrServer };

class PASCALIMPLEMENTATION TMappilaryImage : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	double FCa;
	double FLat;
	double FLng;
	System::UnicodeString FUser_Key;
	System::UnicodeString FUSername;
	System::UnicodeString FKey;
	System::UnicodeString FUser;
	System::UnicodeString FCamera_make;
	System::UnicodeString FCaptured_at;
	bool FPano;
	
public:
	System::TDateTime __fastcall CapturedDateTime();
	__property double Ca = {read=FCa};
	__property double Lat = {read=FLat};
	__property double Lng = {read=FLng};
	__property System::UnicodeString Camera_make = {read=FCamera_make};
	__property System::UnicodeString User = {read=FUser};
	__property System::UnicodeString Key = {read=FKey, write=FKey};
	__property System::UnicodeString Captured_at = {read=FCaptured_at};
	__property System::UnicodeString User_Key = {read=FUser_Key};
	__property System::UnicodeString Username = {read=FUSername};
	__property bool Pano = {read=FPano, nodefault};
public:
	/* TObject.Create */ inline __fastcall TMappilaryImage() : System::TObject() { }
	/* TObject.Destroy */ inline __fastcall virtual ~TMappilaryImage() { }
	
};


#pragma pack(push,4)
class PASCALIMPLEMENTATION TMappilaryImageList : public System::TObject
{
	typedef System::TObject inherited;
	
public:
	TMappilaryImage* operator[](int index) { return this->Images[index]; }
	
private:
	bool FMore;
	System::Generics::Collections::TList__1<TMappilaryImage*>* FImages;
	System::Syncobjs::TCriticalSection* FCritSect;
	TMappilaryImage* __fastcall getImage(int index);
	
public:
	__fastcall TMappilaryImageList();
	__fastcall virtual ~TMappilaryImageList();
	void __fastcall Clear();
	void __fastcall Lock();
	void __fastcall UnLock();
	int __fastcall add(TMappilaryImage* item);
	int __fastcall Count();
	__property bool More = {read=FMore, nodefault};
	__property TMappilaryImage* Images[int index] = {read=getImage/*, default*/};
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TMappilarySequence : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
private:
	TMappilaryCas FCas;
	TMappilaryCoord FCoords;
	System::Classes::TStringList* Fkeys;
	System::UnicodeString FKey;
	System::UnicodeString FCaptured_at;
	bool FPano;
	System::UnicodeString FUser_key;
	System::UnicodeString FUsername;
	System::UnicodeString FCamera_make;
	System::Uitypes::TAlphaColor FColor;
	
public:
	__fastcall TMappilarySequence();
	__fastcall virtual ~TMappilarySequence();
	virtual void __fastcall Assign(System::Classes::TPersistent* Source);
	void __fastcall Clear();
	System::TDateTime __fastcall CapturedDateTime();
	__property TMappilaryCas Cas = {read=FCas};
	__property TMappilaryCoord Coords = {read=FCoords};
	__property System::Classes::TStringList* keys = {read=Fkeys};
	__property System::UnicodeString Key = {read=FKey, write=FKey};
	__property System::UnicodeString User_Key = {read=FUser_key};
	__property System::UnicodeString Username = {read=FUsername};
	__property bool Pano = {read=FPano, nodefault};
	__property System::UnicodeString Camera_make = {read=FCamera_make};
	__property System::UnicodeString Captured_at = {read=FCaptured_at};
	__property System::Uitypes::TAlphaColor Color = {read=FColor, nodefault};
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TMappilarySequenceList : public System::TObject
{
	typedef System::TObject inherited;
	
public:
	TMappilarySequence* operator[](int index) { return this->Sequences[index]; }
	
private:
	bool FMore;
	System::Generics::Collections::TList__1<TMappilarySequence*>* FSequences;
	System::Syncobjs::TCriticalSection* FCritSect;
	TMappilarySequence* __fastcall getSequence(int index);
	
public:
	__fastcall TMappilarySequenceList();
	__fastcall virtual ~TMappilarySequenceList();
	void __fastcall Clear();
	void __fastcall Lock();
	void __fastcall UnLock();
	int __fastcall add(TMappilarySequence* item);
	TMappilarySequence* __fastcall get(const System::UnicodeString Key);
	int __fastcall Count();
	__property bool More = {read=FMore, nodefault};
	__property TMappilarySequence* Sequences[int index] = {read=getSequence/*, default*/};
};

#pragma pack(pop)

class PASCALIMPLEMENTATION TThreadMappilarySearchSequence : public System::Classes::TThread
{
	typedef System::Classes::TThread inherited;
	
private:
	TMappilarySequenceList* FMappilarySequenceList;
	System::Classes::TNotifyEvent FNotifyEvent;
	double FMaxDayInCache;
	System::UnicodeString FLocalFilename;
	System::UnicodeString FUrl;
	Fmx::Uechttp::TuecHttp* FHttp;
	System::UnicodeString data;
	bool Local;
	System::Classes::TStringList* ts;
	void __fastcall doSend();
	
protected:
	virtual void __fastcall Execute();
	
public:
	__fastcall TThreadMappilarySearchSequence(const System::UnicodeString Url, System::Classes::TNotifyEvent NotifyEvent, TMappilarySequenceList* MappilarySequenceList, const double MaxDayInCache, const System::UnicodeString LocalFilename);
	__fastcall virtual ~TThreadMappilarySearchSequence();
	__property System::Classes::TNotifyEvent NotifyEvent = {read=FNotifyEvent, write=FNotifyEvent};
};


class PASCALIMPLEMENTATION TThreadMappilarySearchImage : public System::Classes::TThread
{
	typedef System::Classes::TThread inherited;
	
private:
	TMappilaryImageList* FMappilaryImageList;
	System::Classes::TNotifyEvent FNotifyEvent;
	bool FLocal;
	double FMaxDayInCache;
	System::UnicodeString data;
	System::UnicodeString FLocalFilename;
	System::UnicodeString FUrl;
	Fmx::Uechttp::TuecHttp* FHttp;
	System::Classes::TStringList* ts;
	void __fastcall doSend();
	
protected:
	virtual void __fastcall Execute();
	
public:
	__fastcall TThreadMappilarySearchImage(const System::UnicodeString Url, System::Classes::TNotifyEvent NotifyEvent, TMappilaryImageList* MappilaryImageList, const double MaxDayInCache, const System::UnicodeString LocalFilename);
	__fastcall virtual ~TThreadMappilarySearchImage();
	__property System::Classes::TNotifyEvent NotifyEvent = {read=FNotifyEvent, write=FNotifyEvent};
};


typedef void __fastcall (__closure *TOnGetMappyImage)(const System::UnicodeString Key, Fmx::Graphics::TBitmap* Bitmap);

class PASCALIMPLEMENTATION TThreadMappilarygetImage : public System::Classes::TThread
{
	typedef System::Classes::TThread inherited;
	
private:
	TMappilaryAPI* FMappilaryAPI;
	System::Classes::TNotifyEvent FEvent;
	System::UnicodeString FKey;
	void __fastcall doSend();
	
protected:
	virtual void __fastcall Execute();
	
public:
	__fastcall TThreadMappilarygetImage(TMappilaryAPI* MappilaryAPI, const System::UnicodeString Key, System::Classes::TNotifyEvent Event);
	__fastcall virtual ~TThreadMappilarygetImage();
};


typedef void __fastcall (__closure *TOnMappilartySequences)(TMappilarySequenceList* Sequences);

typedef void __fastcall (__closure *TOnMappilartyImages)(TMappilaryImageList* Images);

class PASCALIMPLEMENTATION TMappilaryAPI : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	Fmx::Uecmapzip::TECMapZip* FMapZip;
	TMappilaryConnexion FMappilaryConnexion;
	Fmx::Graphics::TBitmap* FBitmap;
	System::Classes::TMemoryStream* FMStream;
	TMappilaryThumbSize FThumb;
	double FMaxDayInCache;
	TOnGetMappyImage FOnGetMappyImage;
	System::UnicodeString FKeyGetImage;
	int FDecimalPrecision;
	System::UnicodeString FLocalCache;
	int FPerPage;
	TOnMappilartyImages FOnImage;
	TOnMappilartySequences FOnSequence;
	Fmx::Uecmaputil::TThreadStringList* FWaitUrlSequence;
	Fmx::Uecmaputil::TThreadStringList* FWaitUrlImage;
	Fmx::Uecmaputil::TThreadStringList* FWaitGetImage;
	TThreadMappilarygetImage* FThreadMappilarygetImage;
	TThreadMappilarySearchSequence* FThreadSequence;
	TThreadMappilarySearchImage* FThreadImage;
	TMappilarySequenceList* FSequences;
	TMappilaryImageList* FImages;
	int FPageImage;
	int FPageSequence;
	double FNELat;
	double FNELng;
	double FSWLat;
	double FSWLng;
	System::UnicodeString FClientId;
	System::UnicodeString FBound;
	System::UnicodeString FUrlAPi;
	double FCloseLat;
	double FCloseLng;
	double FMinCa;
	double FMaxCa;
	int FCloseDis;
	System::UnicodeString FCloseData;
	bool FCancelSearchSequence;
	bool FCancelSearchImageClose;
	bool FFlagBound;
	void __fastcall doMappilarySequenceResponse(System::TObject* sender);
	void __fastcall doMappilaryImageResponse(System::TObject* sender);
	void __fastcall doMappilaryGetImageResponse(System::TObject* sender);
	void __fastcall doSearchImageClose();
	
public:
	__fastcall TMappilaryAPI();
	__fastcall virtual ~TMappilaryAPI();
	Fmx::Graphics::TBitmap* __fastcall LoadImage(const System::UnicodeString Key)/* overload */;
	bool __fastcall LoadImage(const System::UnicodeString Key, Fmx::Graphics::TBitmap* Bitmap)/* overload */;
	void __fastcall LoadImage(const System::UnicodeString Key, TOnGetMappyImage OnBitmap)/* overload */;
	bool __fastcall LoadImage(TMappilaryImage* img)/* overload */;
	System::UnicodeString __fastcall UrlImage(const System::UnicodeString Key);
	System::UnicodeString __fastcall LocalPathImage(const System::UnicodeString Key);
	System::UnicodeString __fastcall FilenameImage(const System::UnicodeString Key);
	bool __fastcall LoadSequence(TMappilarySequence* Sequence);
	void __fastcall Bound(double NELat, double NELng, double SWLat, double SWLng);
	void __fastcall SearchSequence();
	void __fastcall SearchImageClose(const double Lat, const double Lng, int Distance);
	void __fastcall CancelSearchSequence();
	void __fastcall CancelSearchImageClose();
	__property bool CanceledSearchSequence = {read=FCancelSearchSequence, nodefault};
	__property bool CanceledSearchImageClose = {read=FCancelSearchImageClose, nodefault};
	__property System::UnicodeString ClientId = {read=FClientId, write=FClientId};
	__property int Page = {read=FPageSequence, nodefault};
	__property int DecimalPrecision = {read=FDecimalPrecision, write=FDecimalPrecision, nodefault};
	__property System::UnicodeString LocalCache = {read=FLocalCache, write=FLocalCache};
	__property TMappilarySequenceList* Sequences = {read=FSequences};
	__property TMappilaryImageList* Images = {read=FImages};
	__property double MinCa = {read=FMinCa, write=FMinCa};
	__property double MaxCa = {read=FMaxCa, write=FMaxCa};
	__property TMappilaryThumbSize Thumb = {read=FThumb, write=FThumb, nodefault};
	__property Fmx::Uecmapzip::TECMapZip* MapZip = {read=FMapZip, write=FMapZip};
	__property TMappilaryConnexion Connexion = {read=FMappilaryConnexion, write=FMappilaryConnexion, nodefault};
	__property double MaxDayInCache = {read=FMaxDayInCache, write=FMaxDayInCache};
	__property int PerPage = {read=FPerPage, write=FPerPage, nodefault};
	__property TOnMappilartySequences OnSequence = {read=FOnSequence, write=FOnSequence};
	__property TOnMappilartyImages OnImage = {read=FOnImage, write=FOnImage};
};


typedef void __fastcall (__closure *TOnMAppilaryClick)(TECMappilaryLayer* Layer, Fmx::Uecnativeshape::TECShape* item, TMappilarySequence* MappilarySequence, int ImageIndex);

typedef void __fastcall (__closure *TOnMappilaySequenceColor)(TECMappilaryLayer* Layer, TMappilarySequence* MappilarySequence, System::Uitypes::TAlphaColor &SequenceColor);

class PASCALIMPLEMENTATION TECMappilaryLayer : public Fmx::Uecnativemapcontrol::TECNativeLayer
{
	typedef Fmx::Uecnativemapcontrol::TECNativeLayer inherited;
	
private:
	System::Classes::TStringList* FKeyList;
	TMappilaryAPI* FMappilary;
	TOnMappilaySequenceColor FOnMappilarySequenceColor;
	TOnMappilartySequences FOnMappilarySequences;
	TOnMAppilaryClick FOnMappilaryClick;
	System::Classes::TNotifyEvent FOnStartSearchSequence;
	void __fastcall doMappilarySequences(TMappilarySequenceList* sender);
	TOnMappilartyImages __fastcall getOnSearchImage();
	void __fastcall setOnSearchImage(TOnMappilartyImages value);
	TMappilarySequenceList* __fastcall getSequences();
	TMappilaryImageList* __fastcall getImages();
	System::UnicodeString __fastcall getClientID();
	void __fastcall setClientID(const System::UnicodeString value);
	System::UnicodeString __fastcall getLocalCache();
	void __fastcall setLocalCache(const System::UnicodeString value);
	void __fastcall doCreateShapeLinePointEditable(System::TObject* sender, Fmx::Uecnativeshape::TECShapes* const Group, Fmx::Uecnativeshape::TECShape* &ShapeLinePoint, const double Lat, const double Lng, const int index);
	TMappilaryThumbSize __fastcall getThumb();
	void __fastcall setThumb(TMappilaryThumbSize value);
	TMappilaryConnexion __fastcall getConnexion();
	void __fastcall setConnexion(TMappilaryConnexion value);
	double __fastcall getMaxDayInCache();
	void __fastcall setMaxDayInCache(const double value);
	bool __fastcall getCancelSearchSequence();
	bool __fastcall getCancelSearchImageClose();
	
protected:
	virtual void __fastcall setVisible(const bool value);
	virtual void __fastcall doOnMapChangeBounds(System::TObject* sender);
	virtual void __fastcall doOnShapeClick(System::TObject* sender);
	void __fastcall doPoiClick(System::TObject* sender, Fmx::Uecnativeshape::TECShape* const item);
	
public:
	__fastcall virtual TECMappilaryLayer(Fmx::Uecnativemapcontrol::TNativeMapControl* _FMap, const System::UnicodeString Name);
	__fastcall virtual ~TECMappilaryLayer();
	void __fastcall CancelSearchSequence();
	void __fastcall CancelSearchImageClose();
	void __fastcall SearchImageClose(const double Lat, const double Lng, int Distance);
	int __fastcall FindImageClose(const double Lat, const double Lng, int Distance, TMappilarySequence* &seq, int &PhotoIndex);
	Fmx::Graphics::TBitmap* __fastcall LoadImage(const System::UnicodeString Key)/* overload */;
	bool __fastcall LoadImage(const System::UnicodeString Key, Fmx::Graphics::TBitmap* Bitmap)/* overload */;
	void __fastcall LoadImage(const System::UnicodeString Key, TOnGetMappyImage OnBitmap)/* overload */;
	bool __fastcall LoadImage(TMappilaryImage* img)/* overload */;
	System::UnicodeString __fastcall UrlImage(const System::UnicodeString Key);
	System::UnicodeString __fastcall LocalPathImage(const System::UnicodeString Key);
	System::UnicodeString __fastcall FilenameImage(const System::UnicodeString Key);
	__property bool CanceledSearchSequence = {read=getCancelSearchSequence, nodefault};
	__property bool CanceledSearchImageClose = {read=getCancelSearchImageClose, nodefault};
	__property System::UnicodeString ClientId = {read=getClientID, write=setClientID};
	__property TMappilaryConnexion Connexion = {read=getConnexion, write=setConnexion, nodefault};
	__property System::UnicodeString LocalCache = {read=getLocalCache, write=setLocalCache};
	__property TMappilaryThumbSize Thumb = {read=getThumb, write=setThumb, nodefault};
	__property TMappilarySequenceList* Sequences = {read=getSequences};
	__property TMappilaryImageList* Images = {read=getImages};
	__property double MaxDayInCache = {read=getMaxDayInCache, write=setMaxDayInCache};
	__property System::Classes::TNotifyEvent OnStartSearchSequence = {read=FOnStartSearchSequence, write=FOnStartSearchSequence};
	__property TOnMAppilaryClick OnClick = {read=FOnMappilaryClick, write=FOnMappilaryClick};
	__property TOnMappilaySequenceColor OnSequenceColor = {read=FOnMappilarySequenceColor, write=FOnMappilarySequenceColor};
	__property TOnMappilartySequences OnSequences = {read=FOnMappilarySequences, write=FOnMappilarySequences};
	__property TOnMappilartyImages OnImages = {read=getOnSearchImage, write=setOnSearchImage};
};


//-- var, const, procedure ---------------------------------------------------
}	/* namespace Uecmappilary */
}	/* namespace Fmx */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_FMX_UECMAPPILARY)
using namespace Fmx::Uecmappilary;
#endif
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_FMX)
using namespace Fmx;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Fmx_UecmappilaryHPP
